;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of CPCtelera: An Amstrad CPC Game Engine 
;;  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

;; Include all CPCtelera constant definitions, macros and variables
.include "cpctelera.h.s"
.include "sys/render_system.h.s"
.include "man/entity_manager.h.s"
.include "cpct_functions.h.s"
.include "man/game.h.s"
.include "sys/menu.h.s"

.area _DATA

.area _CODE

;;
;; MAIN function. This is the entry point of the application.
;;    _main:: global symbol is required for correctly compiling and linking
;;

; decompress_buffer = 0x155
; maxsize = 0x4000
; decompress_buffer_end = decompress_buffer + maxsize

_main::

   ;; Disable firmware to prevent it from interfering with string drawing
   call cpct_disableFirmware_asm


   ;Initialize music
    ld    de, #_array_song
    call  cpct_akp_musicInit_asm

   inicio:

   ;First time it shows the menu and then calls game_init and jumps into the game loop
   call sys_menu_update

   call man_game_init

   loop:
      call man_game_update

      ld a, (JUEGO_TERMINADO)
      cp #1
      jr z, inicio

      call cpct_waitVSYNC_asm
      call cpct_akp_musicPlay_asm
      call man_game_render

   jr loop

