; ENTITY MANAGER H

; PUBLIC FUNCTIONS
.globl entityman_getEntityArray
.globl entityman_create
.globl entityman_getEntityArray_Collisions
.globl entityman_reset

;Entity DEFINITION MACRO
.macro DefineEntityDefault _x, _y, _vx, _vy, _w, _h, _sp, aist
   .db _x ;;X position of entity
   .db _y
   .db _vx
   .db _vy
   .db _w
   .db _h
   .dw _sp
   .db 0x00, 0x00 ;; ai aim at
   .db aist       ;; ai status
   .dw 0xCCCC
.endm

.macro DefineEntity _name, _x, _y, _vx, _vy, _w, _h, _sp, aist
   _name::
      DefineEntityDefault _x, _y, _vx, _vy, _w, _h, _sp, aist
.endm
;Sign DEFINITION MACRO
.macro DefineSignDefault _x, _y, _w, _h, _sp
   .db _x ;;X position of entity
   .db _y
   .db _w
   .db _h
   .dw _sp
.endm

.macro DefineSign _name, _x, _y, _w, _h, _sp
   _name::
      DefineSignDefault _x, _y, _w, _h, _sp
.endm

s_x = 0
s_y = 1
s_w = 2
s_h = 3
s_sp_l = 4
s_sp_h = 5
sizeof_s = 6

e_x = 0
e_y = 1
e_vx = 2
e_vy = 3
e_w = 4
e_h = 5
e_sp_l = 6
e_sp_h = 7
e_ai_aim_x = 8
e_ai_aim_y = 9
e_ai_st = 10
e_lastVP_l = 11
e_lastVP_h = 12
sizeof_e = 13

;; Entity t AI-status enum
e_ai_st_noAI     = 0
e_ai_st_stand_by = 1
e_ai_st_move_to  = 2

.macro DefineEntityArray _name, _N
_name::
   .rept _N
      DefineEntityDefault 0xDE, 0xAD, 0xDE, 0xAD, 0xDE, 0xAD, 0x0000, e_ai_st_noAI
   .endm
.endm

.macro DefineSignArray _name, _N
_name::
   .rept _N
      DefineSignDefault 0xDE, 0xAD, 0xDE, 0xAD, 0x0000
   .endm
.endm

;SPRITE AND PALETTE POINTERS
.globl _palette
.globl _sp_player
.globl _sp_enemy1
.globl _sp_ball
.globl _sp_marc_00
.globl _sp_marc_15
.globl _sp_marc_30
.globl _sp_marc_40
.globl _sp_ee
.globl _mygraphics_end
.globl _mygraphics_menu_end
.globl _mygraphics_credits_end
.globl _mygraphics_controls_end
   
.globl _score_player
.globl _score_cpu
.globl _array_song
.globl _partido
