;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Retro Tennis Super Wave 
;;  Copyright (C) 2019 Bamboo Studio 
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  Bamboo Studio.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program.  If not, see http://www.gnu.org/licenses/.
;;------------------------------------------------------------------------------
;;ENTITY MANAGER

.include "entity_manager.h.s"
max_entities == 3

_num_entities:: .db 0
_last_elem_ptr:: .dw _entity_array
DefineEntityArray _entity_array, max_entities

_last_sign_ptr:: .dw _sign_array
DefineEntityArray _sign_array, max_entities

entityman_getSignArray::
	ld 	ix, #_sign_array
	ret

entityman_getEntityArray::
	ld 	ix, #_entity_array
	ld    a, (_num_entities)
	ret

entityman_getEntityArray_Collisions::
	ld 	ix, #_entity_array
	ld 	iy, #_entity_array
	ld    a, (_num_entities)
	ret


;; INPUT
;; HL: Pointer to entity initializer bytes
entityman_create::
	ld 		de, (_last_elem_ptr)
	ld 		bc, #sizeof_e
	ldir

	ld 		a, (_num_entities)
	inc 	a
	ld 		(_num_entities), a

	ld 		hl, (_last_elem_ptr)
	ld 		bc, #sizeof_e
	add 	hl, bc
	ld 		(_last_elem_ptr), hl 

	ret

entityman_sign_create::
	ld 		de, (_last_sign_ptr)
	ld 		bc, #sizeof_s
	ldir

	ld 		hl, (_last_sign_ptr)
	ld 		bc, #sizeof_s
	add 	hl, bc
	ld 		(_last_sign_ptr), hl 

	ret

entityman_sign_reset::

 	ld hl, (_sign_array)
 	ld (_last_sign_ptr), hl

	ret

entityman_reset::
	ld a, #0
 	ld (_num_entities), a

 	ld hl, (_entity_array)
 	ld (_last_elem_ptr), hl

	ret