;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Retro Tennis Super Wave 
;;  Copyright (C) 2019 Bamboo Studio 
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  Bamboo Studio.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program.  If not, see http://www.gnu.org/licenses/.
;;------------------------------------------------------------------------------
.include "cpctelera.h.s"
.include "sys/render_system.h.s"
.include "man/entity_manager.h.s"
.include "cpct_functions.h.s"
.include "man/game.h.s"

string_1: .asciz "DEFEAT"
string_2: .asciz "VICTORY"
string_3: .asciz "Press enter to exit"

sys_menu_update::
   call clear_screen
   call set_color

   paint_menu:
   ;Unzip background
   ld    hl, #_mygraphics_menu_end
   ld    de, #0xFFFF
   call  cpct_zx7b_decrunch_s_asm

   loop_start:

      call  cpct_scanKeyboard_f_asm
      ld    hl, #Key_O
      call  cpct_isKeyPressed_asm
      jr    z, O_NotPressed

      O_Pressed:
         ;Vamos a los controles
         ;jr mostrar_controles      
         jr mostrar_creditos               

      O_NotPressed:
         call  cpct_scanKeyboard_f_asm    
         ld    hl, #Key_P 
         call  cpct_isKeyPressed_asm
         jr       z, P_NotPressed

      P_Pressed:
         ;Vamos a los creditos
         jr mostrar_controles

      P_NotPressed:

         call  cpct_scanKeyboard_f_asm
         ld    hl, #Key_Space
         call  cpct_isKeyPressed_asm
         jr    z, loop_start
         
   ret

   ;;Print credits
   mostrar_creditos:
      ;; Before calling drawstring, we first need to set up the PEN colours by calling cpct_setDrawCharM1_asm
      call clear_screen

      ;Unzip background
      ld    hl, #_mygraphics_credits_end
      ld    de, #0xFFFF
      call  cpct_zx7b_decrunch_s_asm

      call loop_key

      call clear_screen
   jp paint_menu


   ;;Print controls
   mostrar_controles:
      ;; Before calling drawstring, we first need to set up the PEN colours by calling cpct_setDrawCharM1_asm
      call clear_screen

      ;Unzip background
      ld    hl, #_mygraphics_controls_end
      ld    de, #0xFFFF
      call  cpct_zx7b_decrunch_s_asm

      call loop_key

      call clear_screen
   jp paint_menu

   ;;PANTALLA DE DERROTA
   mostrar_derrota::
      call set_color
      ;; Before calling drawstring, we first need to set up the PEN colours by calling cpct_setDrawCharM1_asm

      call clear_screen

      ld    de, #0xc000
      ld    b, #70 ;y
      ld    c, #108 ;x
      call cpct_getScreenPtr_asm

      ld   iy, #string_1  
      call cpct_drawStringM0_asm 

      ld    de, #0xc000
      ld    b, #180 ;y
      ld    c, #2 ;x
      call cpct_getScreenPtr_asm

      ld   iy, #string_3  
      call cpct_drawStringM0_asm 

      call loop_key
      call clear_screen
   ret

   mostrar_victoria::
      call set_color
      ;; Before calling drawstring, we first need to set up the PEN colours by calling cpct_setDrawCharM1_asm

      call clear_screen


      ld    de, #0xc000
      ld    b, #70 ;y
      ld    c, #105 ;x
      call cpct_getScreenPtr_asm

      ld   iy, #string_2  
      call cpct_drawStringM0_asm 

      ld    de, #0xc000
      ld    b, #180 ;y
      ld    c, #2 ;x
      call cpct_getScreenPtr_asm

      ld   iy, #string_3  
      call cpct_drawStringM0_asm 

      call loop_key
      call clear_screen
   ret

   loop_key::
      loop_ret:
         call  cpct_scanKeyboard_f_asm
         ld    hl, #Key_Return
         call  cpct_isKeyPressed_asm
      jp   z, loop_ret
   ret

   clear_screen::
      ld    de, #0xc000
      ld    bc, #0x4000
      ld     a, #0x00
      call cpct_memset_asm
   ret 

   set_color::
       ld    c, #0 ; MODE 1
       call  cpct_setVideoMode_asm ;Sets the video mode
       ld    hl, #_palette ;Palette array
       ld    de, #16 ;Size of the palette
       call  cpct_setPalette_asm ;Set palette
   ret
